# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

class Tuple(tvtk_base.TVTKBase):
    """
    Tuple - templated base type for containers of constant size.
    
    This class is a templated data type for storing and manipulating
    tuples.
    
    
    Provided Types:
    
      Tuple[float64,3] => Tuple<double, 3>
      Tuple[float32,3] => Tuple<float, 3>
      Tuple[uint8,3] => Tuple<unsigned char, 3>
      Tuple[float64,4] => Tuple<double, 4>
      Tuple[float32,4] => Tuple<float, 4>
      Tuple[uint8,4] => Tuple<unsigned char, 4>
      Tuple[int32,4] => Tuple<int, 4>
      Tuple[float64,2] => Tuple<double, 2>
      Tuple[float32,2] => Tuple<float, 2>
      Tuple[int32,2] => Tuple<int, 2>
      Tuple[int32,3] => Tuple<int, 3>
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkTuple, obj, update, **traits)
    
    _updateable_traits_ = \
    ()
    
    _full_traitnames_list_ = \
    ([])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Tuple, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit Tuple properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View(([], [], []),
            title='Edit Tuple properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Tuple properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

